blob: a1436543fbeeca38e72df0ad1cb727015ca1dd47 [file] [log] [blame]
Pali Rohár2def7412020-10-31 17:32:48 +01001#!/bin/bash -e
Pali Rohár80ad67b2020-05-17 14:38:22 +02002# SPDX-License-Identifier: GPL-2.0+
3# (C) 2020 Pali Rohár <pali@kernel.org>
4
5# External tools needed for this test:
6echo '
7 wget
8 git
9 truncate
10 tar
11 dpkg
12 dd
13 make
14 gcc
15 arm-linux-gnueabi-gcc
16 fakeroot (homepage http://fakeroot-ng.lingnu.com/)
17 mcopy (from mtools, homepage http://www.gnu.org/software/mtools/)
18 mformat (from mtools, homepage http://www.gnu.org/software/mtools/)
19 /usr/sbin/mkfs.ubifs (from mtd-utils, homepage http://www.linux-mtd.infradead.org/)
20 /usr/sbin/ubinize (from mtd-utils, homepage http://www.linux-mtd.infradead.org/)
21' | while read tool info; do
22 if test -z "$tool"; then continue; fi
23 if ! which $tool 1>/dev/null 2>&1; then
24 echo "Tool $tool was not found and is required to run this test"
25 echo "First install $tool $info"
26 exit 1
27 fi
28done || exit 1
29
30echo
31echo "============================================================"
32echo "========== Compiling U-Boot for Nokia RX-51 board =========="
33echo "============================================================"
34echo
35
36# First compile u-boot.bin binary for Nokia RX-51 board
37make nokia_rx51_config
38make -j4 u-boot.bin ARCH=arm CROSS_COMPILE=arm-linux-gnueabi-
39
40# And then do all stuff in temporary directory
41mkdir -p nokia_rx51_tmp
42cd nokia_rx51_tmp
43
44test -f mkimage || ln -s ../tools/mkimage .
45test -f u-boot.bin || ln -s ../u-boot.bin .
46
47echo
48echo "=========================================================================="
49echo "========== Downloading and compiling qemu from qemu-linaro fork =========="
50echo "=========================================================================="
51echo
52
53# Download and compile linaro version qemu which has support for n900 machine
54# Last working commit is 8f8d8e0796efe1a6f34cdd83fb798f3c41217ec1
55if ! test -f qemu-system-arm; then
56 test -d qemu-linaro || git clone https://git.linaro.org/qemu/qemu-linaro.git
57 cd qemu-linaro
58 git checkout 8f8d8e0796efe1a6f34cdd83fb798f3c41217ec1
Tom Rinic8982d22021-06-10 10:57:36 -040059 ./configure --enable-system --target-list=arm-softmmu --python=/usr/bin/python2.7 --disable-sdl --disable-gtk --disable-curses --audio-drv-list= --audio-card-list= --disable-werror --disable-xen --disable-xen-pci-passthrough --disable-brlapi --disable-vnc --disable-curl --disable-slirp --disable-kvm --disable-user --disable-linux-user --disable-bsd-user --disable-guest-base --disable-uuid --disable-vde --disable-linux-aio --disable-cap-ng --disable-attr --disable-blobs --disable-docs --disable-spice --disable-libiscsi --disable-smartcard-nss --disable-usb-redir --disable-guest-agent --disable-seccomp --disable-glusterfs --disable-nptl --disable-fdt
Pali Rohár80ad67b2020-05-17 14:38:22 +020060 make -j4
61 cd ..
62 ln -s qemu-linaro/arm-softmmu/qemu-system-arm .
63fi
64
65echo
66echo "==================================================="
67echo "========== Downloading external binaries =========="
68echo "==================================================="
69echo
70
71# Download qflasher and nolo images
72# This is proprietary qemu flasher tool with first stage images, but license allows non-commercial redistribution
73wget -c http://repository.maemo.org/qemu-n900/qemu-n900.tar.gz
74tar -xf qemu-n900.tar.gz
75
76# Download Maemo script u-boot-gen-combined
77if ! test -f u-boot-gen-combined; then
78 test -d u-boot-maemo || git clone https://github.com/pali/u-boot-maemo.git
79 chmod +x u-boot-maemo/debian/u-boot-gen-combined
80 ln -s u-boot-maemo/debian/u-boot-gen-combined .
81fi
82
83# Download Maemo fiasco kernel
84wget -c http://repository.maemo.org/pool/maemo5.0/free/k/kernel/kernel_2.6.28-20103103+0m5_armel.deb
85dpkg -x kernel_2.6.28-20103103+0m5_armel.deb kernel_2.6.28
86
87# Download Maemo libc
88wget -c http://repository.maemo.org/pool/maemo5.0/free/g/glibc/libc6_2.5.1-1eglibc27+0m5_armel.deb
89dpkg -x libc6_2.5.1-1eglibc27+0m5_armel.deb libc6_2.5.1
90
91# Download Maemo busybox
92wget -c http://repository.maemo.org/pool/maemo5.0/free/b/busybox/busybox_1.10.2.legal-1osso30+0m5_armel.deb
93dpkg -x busybox_1.10.2.legal-1osso30+0m5_armel.deb busybox_1.10.2
94
95echo
96echo "======================================="
97echo "========== Generating images =========="
98echo "======================================="
99echo
100
101# Generate rootfs directory
102mkdir -p rootfs
103mkdir -p rootfs/dev/
104mkdir -p rootfs/bin/
105mkdir -p rootfs/sbin/
106mkdir -p rootfs/lib/
107cp -a busybox_1.10.2/bin/busybox rootfs/bin/
108cp -a libc6_2.5.1/lib/ld-linux.so.3 rootfs/lib/
109cp -a libc6_2.5.1/lib/ld-2.5.so rootfs/lib/
110cp -a libc6_2.5.1/lib/libc.so.6 rootfs/lib/
111cp -a libc6_2.5.1/lib/libc-2.5.so rootfs/lib/
112cp -a libc6_2.5.1/lib/libcrypt.so.1 rootfs/lib/
113cp -a libc6_2.5.1/lib/libcrypt-2.5.so rootfs/lib/
114test -f rootfs/bin/sh || ln -sf busybox rootfs/bin/sh
115test -f rootfs/sbin/poweroff || ln -sf ../bin/busybox rootfs/sbin/poweroff
116cat > rootfs/sbin/preinit << EOF
117#!/bin/sh
118echo
119echo "Successfully booted"
120echo
121/sbin/poweroff -f
122EOF
123chmod +x rootfs/sbin/preinit
124
125# Generate ubi config file for ubi rootfs image
126cat > ubi.ini << EOF
127[rootfs]
128mode=ubi
129image=ubifs.img
130vol_id=0
131vol_size=160MiB
132vol_type=dynamic
133vol_name=rootfs
134vol_alignment=1
135vol_flags=autoresize
136EOF
137
138# Generate ubi rootfs image from rootfs directory
139# NOTE: Character device on host filesystem can be created only by root
140# But we do not need it on host filesystem, just in ubifs image
141# So run mknod and mkfs.ubifs commands under fakeroot program
142# which via LD_PRELOAD simulate mknod() and stat() functions
143# so mkfs.ubifs will see dev/console as character device and
144# put it correctly as character device into final ubifs image
145# Therefore we can run whole script as non-root nobody user
146fakeroot sh -c '
147 rm -f rootfs/dev/console;
148 mknod rootfs/dev/console c 5 1;
149 /usr/sbin/mkfs.ubifs -m 2048 -e 129024 -c 2047 -r rootfs ubifs.img;
150'
151/usr/sbin/ubinize -o ubi.img -p 128KiB -m 2048 -s 512 ubi.ini
152
Pali Rohár9d12a9b2020-11-29 17:15:05 +0100153# Generate bootmenu for U-Boot serial console testing
154cat > bootmenu_uboot << EOF
155setenv bootmenu_0 'Serial console test=echo; echo "Testing serial console"; echo; echo "Successfully booted"; echo; poweroff';
156setenv bootmenu_1;
157setenv bootmenu_delay 1;
158setenv bootdelay 1;
159EOF
160./mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n bootmenu_uboot -d bootmenu_uboot bootmenu_uboot.scr
161
Pali Rohár0a8825c2021-06-18 15:27:03 +0200162# Generate bootmenu for eMMC booting (uImage)
Pali Rohár80ad67b2020-05-17 14:38:22 +0200163cat > bootmenu_emmc << EOF
164setenv bootmenu_0 'uImage-2.6.28-omap1 from eMMC=setenv mmcnum 1; setenv mmcpart 1; setenv mmctype fat; setenv bootargs; setenv setup_omap_atag 1; setenv mmckernfile uImage-2.6.28-omap1; run trymmckernboot';
165setenv bootmenu_1;
166setenv bootmenu_delay 1;
167setenv bootdelay 1;
168EOF
Pali Rohár2def7412020-10-31 17:32:48 +0100169./mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n bootmenu_emmc -d bootmenu_emmc bootmenu_emmc.scr
Pali Rohár80ad67b2020-05-17 14:38:22 +0200170
Pali Rohár0a8825c2021-06-18 15:27:03 +0200171# Generate bootmenu for eMMC booting (zImage)
172cat > bootmenu_emmc2 << EOF
173setenv bootmenu_0 'zImage-2.6.28-omap1 from eMMC=setenv mmcnum 1; setenv mmcpart 1; setenv mmctype fat; setenv bootargs; setenv setup_omap_atag 1; setenv mmckernfile zImage-2.6.28-omap1; run trymmckernboot';
174setenv bootmenu_1;
175setenv bootmenu_delay 1;
176setenv bootdelay 1;
177EOF
178./mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n bootmenu_emmc2 -d bootmenu_emmc2 bootmenu_emmc2.scr
179
Pali Rohár80ad67b2020-05-17 14:38:22 +0200180# Generate bootmenu for OneNAND booting
181cat > bootmenu_nand << EOF
182setenv bootmenu_0 'uImage-2.6.28-omap1 from OneNAND=mtd read initfs \${kernaddr}; setenv bootargs; setenv setup_omap_atag 1; bootm \${kernaddr}';
183setenv bootmenu_1;
184setenv bootmenu_delay 1;
185setenv bootdelay 1;
186EOF
Pali Rohár2def7412020-10-31 17:32:48 +0100187./mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n bootmenu_nand -d bootmenu_nand bootmenu_nand.scr
Pali Rohár80ad67b2020-05-17 14:38:22 +0200188
Pali Rohár0a8825c2021-06-18 15:27:03 +0200189# Generate bootmenu for default booting
190cat > bootmenu_default << EOF
191setenv bootmenu_delay 1;
192setenv bootdelay 1;
193EOF
194./mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n bootmenu_default -d bootmenu_default bootmenu_default.scr
195
Pali Rohár80ad67b2020-05-17 14:38:22 +0200196# Generate combined image from u-boot and Maemo fiasco kernel
197dd if=kernel_2.6.28/boot/zImage-2.6.28-20103103+0m5.fiasco of=zImage-2.6.28-omap1 skip=95 bs=1
Pali Rohár0a8825c2021-06-18 15:27:03 +0200198./u-boot-gen-combined u-boot.bin zImage-2.6.28-omap1 combined_zimage.bin
Pali Rohár80ad67b2020-05-17 14:38:22 +0200199./mkimage -A arm -O linux -T kernel -C none -a 80008000 -e 80008000 -n zImage-2.6.28-omap1 -d zImage-2.6.28-omap1 uImage-2.6.28-omap1
Pali Rohár0a8825c2021-06-18 15:27:03 +0200200./u-boot-gen-combined u-boot.bin uImage-2.6.28-omap1 combined_uimage.bin
Pali Rohár80ad67b2020-05-17 14:38:22 +0200201
202# Generate combined hack image from u-boot and Maemo fiasco kernel (kernel starts at 2MB offset and qflasher puts 2kB header before supplied image)
203cp u-boot.bin combined_hack.bin
204dd if=uImage-2.6.28-omap1 of=combined_hack.bin bs=1024 seek=$((2048-2))
205
Pali Rohár9d12a9b2020-11-29 17:15:05 +0100206# Generate FAT32 eMMC image for U-Boot serial console testing
207truncate -s 50MiB emmc_uboot.img
208mformat -m 0xf8 -F -h 4 -s 16 -c 1 -t $((50*1024*1024/(4*16*512))) :: -i emmc_uboot.img
209mcopy bootmenu_uboot.scr ::/bootmenu.scr -i emmc_uboot.img
210
Pali Rohár0a8825c2021-06-18 15:27:03 +0200211# Generate FAT32 eMMC image for eMMC booting (uImage)
Pali Rohár80ad67b2020-05-17 14:38:22 +0200212truncate -s 50MiB emmc_emmc.img
213mformat -m 0xf8 -F -h 4 -s 16 -c 1 -t $((50*1024*1024/(4*16*512))) :: -i emmc_emmc.img
214mcopy uImage-2.6.28-omap1 ::/uImage-2.6.28-omap1 -i emmc_emmc.img
215mcopy bootmenu_emmc.scr ::/bootmenu.scr -i emmc_emmc.img
216
Pali Rohár0a8825c2021-06-18 15:27:03 +0200217# Generate FAT32 eMMC image for eMMC booting (zImage)
218truncate -s 50MiB emmc_emmc2.img
219mformat -m 0xf8 -F -h 4 -s 16 -c 1 -t $((50*1024*1024/(4*16*512))) :: -i emmc_emmc2.img
220mcopy zImage-2.6.28-omap1 ::/zImage-2.6.28-omap1 -i emmc_emmc2.img
221mcopy bootmenu_emmc2.scr ::/bootmenu.scr -i emmc_emmc2.img
222
Pali Rohár80ad67b2020-05-17 14:38:22 +0200223# Generate FAT32 eMMC image for OneNAND booting
224truncate -s 50MiB emmc_nand.img
225mformat -m 0xf8 -F -h 4 -s 16 -c 1 -t $((50*1024*1024/(4*16*512))) :: -i emmc_nand.img
226mcopy bootmenu_nand.scr ::/bootmenu.scr -i emmc_nand.img
227
Pali Rohár0a8825c2021-06-18 15:27:03 +0200228# Generate FAT32 eMMC image for default booting
229truncate -s 50MiB emmc_default.img
230mformat -m 0xf8 -F -h 4 -s 16 -c 1 -t $((50*1024*1024/(4*16*512))) :: -i emmc_default.img
231mcopy bootmenu_default.scr ::/bootmenu.scr -i emmc_default.img
232
Pali Rohár9d12a9b2020-11-29 17:15:05 +0100233# Generate MTD image for U-Boot serial console testing
234rm -f mtd_uboot.img
235./qflasher -v -x xloader-qemu.bin -s secondary-qemu.bin -k u-boot.bin -m rx51 -o mtd_uboot.img
236
Pali Rohár80ad67b2020-05-17 14:38:22 +0200237# Generate MTD image for RAM booting from bootloader nolo images, compiled image and rootfs image
238rm -f mtd_ram.img
Pali Rohár0a8825c2021-06-18 15:27:03 +0200239./qflasher -v -x xloader-qemu.bin -s secondary-qemu.bin -k combined_uimage.bin -r ubi.img -m rx51 -o mtd_ram.img
240rm -f mtd_ram2.img
241./qflasher -v -x xloader-qemu.bin -s secondary-qemu.bin -k combined_zimage.bin -r ubi.img -m rx51 -o mtd_ram2.img
Pali Rohár80ad67b2020-05-17 14:38:22 +0200242
243# Generate MTD image for eMMC booting from bootloader nolo images, u-boot image and rootfs image
244rm -f mtd_emmc.img
245./qflasher -v -x xloader-qemu.bin -s secondary-qemu.bin -k u-boot.bin -r ubi.img -m rx51 -o mtd_emmc.img
246
247# Generate MTD image for OneNAND booting from bootloader nolo images, combined hacked image and rootfs image
248# Kernel image is put into initfs area, but qflasher reject to copy kernel image into initfs area because it does not have initfs signature
249# This is hack to workaround this problem, tell qflasher that kernel area for u-boot is bigger and put big combined hacked image (u-boot + kernel with correct offset)
250rm -f mtd_nand.img
251./qflasher -v -x xloader-qemu.bin -s secondary-qemu.bin -k combined_hack.bin -r ubi.img -m rx51 -p k=4094,i=2 -o mtd_nand.img
252
253echo
254echo "======================================================"
255echo "========== Running test images in n900 qemu =========="
256echo "======================================================"
257echo
258
Pali Rohár9d12a9b2020-11-29 17:15:05 +0100259# Run MTD image in qemu and wait for 300s if U-Boot prints testing string to serial console and poweroff
260rm -f qemu_uboot.log
261./qemu-system-arm -M n900 -mtdblock mtd_uboot.img -sd emmc_uboot.img -serial /dev/stdout -display none > qemu_uboot.log &
262qemu_pid=$!
263tail -F qemu_uboot.log &
264tail_pid=$!
265sleep 300 &
266sleep_pid=$!
267wait -n $sleep_pid $qemu_pid || true
268kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
269wait || true
270
Pali Rohár0a8825c2021-06-18 15:27:03 +0200271# Run MTD image in qemu and wait for 300s if uImage kernel from RAM is correctly booted
Pali Rohár80ad67b2020-05-17 14:38:22 +0200272rm -f qemu_ram.log
273./qemu-system-arm -M n900 -mtdblock mtd_ram.img -serial /dev/stdout -display none > qemu_ram.log &
274qemu_pid=$!
275tail -F qemu_ram.log &
276tail_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100277sleep 300 &
Pali Rohár80ad67b2020-05-17 14:38:22 +0200278sleep_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100279wait -n $sleep_pid $qemu_pid || true
280kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
281wait || true
Pali Rohár80ad67b2020-05-17 14:38:22 +0200282
Pali Rohár0a8825c2021-06-18 15:27:03 +0200283# Run MTD image in qemu and wait for 300s if zImage kernel from RAM is correctly booted
284rm -f qemu_ram2.log
285./qemu-system-arm -M n900 -mtdblock mtd_ram2.img -sd emmc_default.img -serial /dev/stdout -display none > qemu_ram2.log &
286qemu_pid=$!
287tail -F qemu_ram2.log &
288tail_pid=$!
289sleep 300 &
290sleep_pid=$!
291wait -n $sleep_pid $qemu_pid || true
292kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
293wait || true
294
295# Run MTD image in qemu and wait for 300s if uImage kernel from eMMC is correctly booted
Pali Rohár80ad67b2020-05-17 14:38:22 +0200296rm -f qemu_emmc.log
297./qemu-system-arm -M n900 -mtdblock mtd_emmc.img -sd emmc_emmc.img -serial /dev/stdout -display none > qemu_emmc.log &
298qemu_pid=$!
299tail -F qemu_emmc.log &
300tail_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100301sleep 300 &
Pali Rohár80ad67b2020-05-17 14:38:22 +0200302sleep_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100303wait -n $sleep_pid $qemu_pid || true
304kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
305wait || true
Pali Rohár80ad67b2020-05-17 14:38:22 +0200306
Pali Rohár0a8825c2021-06-18 15:27:03 +0200307# Run MTD image in qemu and wait for 300s if zImage kernel from eMMC is correctly booted
308rm -f qemu_emmc2.log
309./qemu-system-arm -M n900 -mtdblock mtd_emmc.img -sd emmc_emmc2.img -serial /dev/stdout -display none > qemu_emmc2.log &
310qemu_pid=$!
311tail -F qemu_emmc2.log &
312tail_pid=$!
313sleep 300 &
314sleep_pid=$!
315wait -n $sleep_pid $qemu_pid || true
316kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
317wait || true
318
Pali Rohár80ad67b2020-05-17 14:38:22 +0200319# Run MTD image in qemu and wait for 300s if kernel from OneNAND is correctly booted
320rm -f qemu_nand.log
321./qemu-system-arm -M n900 -mtdblock mtd_nand.img -sd emmc_nand.img -serial /dev/stdout -display none > qemu_nand.log &
322qemu_pid=$!
323tail -F qemu_nand.log &
324tail_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100325sleep 300 &
Pali Rohár80ad67b2020-05-17 14:38:22 +0200326sleep_pid=$!
Pali Rohár2def7412020-10-31 17:32:48 +0100327wait -n $sleep_pid $qemu_pid || true
328kill -9 $tail_pid $sleep_pid $qemu_pid 2>/dev/null || true
329wait || true
Pali Rohár80ad67b2020-05-17 14:38:22 +0200330
331echo
332echo "============================="
333echo "========== Results =========="
334echo "============================="
335echo
336
Pali Rohár9d12a9b2020-11-29 17:15:05 +0100337if grep -q 'Successfully booted' qemu_uboot.log; then echo "U-Boot serial console is working"; else echo "U-Boot serial console test failed"; fi
Pali Rohár0a8825c2021-06-18 15:27:03 +0200338if grep -q 'Successfully booted' qemu_ram.log; then echo "Kernel (uImage) was successfully booted from RAM"; else echo "Failed to boot kernel (uImage) from RAM"; fi
339if grep -q 'Successfully booted' qemu_ram2.log; then echo "Kernel (zImage) was successfully booted from RAM"; else echo "Failed to boot kernel (zImage) from RAM"; fi
340if grep -q 'Successfully booted' qemu_emmc.log; then echo "Kernel (uImage) was successfully booted from eMMC"; else echo "Failed to boot kernel (uImage) from eMMC"; fi
341if grep -q 'Successfully booted' qemu_emmc2.log; then echo "Kernel (zImage) was successfully booted from eMMC"; else echo "Failed to boot kernel (zImage) from eMMC"; fi
342if grep -q 'Successfully booted' qemu_nand.log; then echo "Kernel (uImage) was successfully booted from OneNAND"; else echo "Failed to boot kernel (uImage) from OneNAND"; fi
Pali Rohár80ad67b2020-05-17 14:38:22 +0200343
344echo
345
Pali Rohár0a8825c2021-06-18 15:27:03 +0200346if grep -q 'Successfully booted' qemu_uboot.log && grep -q 'Successfully booted' qemu_ram.log && grep -q 'Successfully booted' qemu_ram2.log && grep -q 'Successfully booted' qemu_emmc.log && grep -q 'Successfully booted' qemu_emmc2.log && grep -q 'Successfully booted' qemu_nand.log; then
Pali Rohár80ad67b2020-05-17 14:38:22 +0200347 echo "All tests passed"
348 exit 0
349else
350 echo "Some tests failed"
351 exit 1
352fi